<template>
  <div class="app-container">
<!--    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">-->
<!--      <el-form-item label="跳转地址" prop="redirect">-->
<!--        <el-input-->
<!--          v-model="queryParams.redirect"-->
<!--          placeholder="请输入跳转地址"-->
<!--          clearable-->
<!--          @keyup.enter.native="handleQuery"-->
<!--        />-->
<!--      </el-form-item>-->
<!--      <el-form-item>-->
<!--        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>-->
<!--        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>-->
<!--      </el-form-item>-->
<!--    </el-form>-->

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['system:ads:add']"
        >{{$t('ads.新增')}}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['system:ads:edit']"
        >{{$t('ads.修改')}}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['system:ads:remove']"
        >{{$t('ads.删除')}}</el-button>
      </el-col>
<!--      <el-col :span="1.5">-->
<!--        <el-button-->
<!--          type="warning"-->
<!--          plain-->
<!--          icon="el-icon-download"-->
<!--          size="mini"-->
<!--          @click="handleExport"-->
<!--          v-hasPermi="['system:ads:export']"-->
<!--        >导出</el-button>-->
<!--      </el-col>-->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="adsList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="id" align="center" prop="id" />
      <el-table-column :label="$t('ads.图片')" align="center" prop="poster" >
        <template slot-scope="scope">
          <image-preview :src="scope.row.poster" :width="50" :height="50"/>
        </template>
      </el-table-column>
      <el-table-column :label="$t('ads.跳转地址')"  align="center" prop="redirect" />
      <el-table-column :label="$t('ads.状态')"  align="center" prop="status" >
        <template slot-scope="scope">
          <el-tag v-if="scope.row.status==0" >{{$t('ads.开启')}}</el-tag>
          <el-tag v-if="scope.row.status==1" >{{$t('ads.关闭')}}</el-tag>
        </template>
      </el-table-column>
<!--      <el-table-column label="${comment}" align="center" prop="remark" />-->
      <el-table-column :label="$t('ads.操作')" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:ads:edit']"
          >{{$t('ads.修改')}}</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['system:ads:remove']"
          >{{$t('ads.删除')}}</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改首页广告对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item :label="$t('ads.图片')" prop="poster">
          <image-upload :limit="1" v-model="form.poster"/>
        </el-form-item>
        <el-form-item :label="$t('ads.跳转地址')" prop="redirect">
          <el-input v-model="form.redirect" :placeholder="$t('ads.请输入跳转地址')" />
        </el-form-item>
        <el-form-item :label="$t('ads.排序')" prop="sort">
          <el-input v-model="form.sort" type="number"  :placeholder="$t('ads.请输入排序')" />
        </el-form-item>
        <el-form-item :label="$t('ads.状态')" prop="status">
          <el-radio-group v-model="form.status">
            <el-radio label="0">{{$t('ads.开启')}}</el-radio>
            <el-radio label="1">{{$t('ads.关闭')}}</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>

      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">{{$t('ads.确 定')}}</el-button>
        <el-button @click="cancel">{{$t('ads.取 消')}}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listAds, getAds, delAds, addAds, updateAds } from "@/api/system/ads";

export default {
  name: "Ads",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 首页广告表格数据
      adsList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        poster: null,
        redirect: null,
        status: null,
        deleted: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        poster: [
          { required: true, message: this.$t("图片不能为空"), trigger: "blur" }
        ],
        status: [
          { required: true, message: this.$t("状态不能为空"), trigger: "change" }
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询首页广告列表 */
    getList() {
      this.loading = true;
      listAds(this.queryParams).then(response => {
        this.adsList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        poster: null,
        redirect: null,
        status: null,
        createTime: null,
        updateTime: null,
        deleted: null,
        remark: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title =this.$t('ads.添加首页广告');
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getAds(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title =this.$t('ads.修改首页广告');
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateAds(this.form).then(response => {
              this.$modal.msgSuccess(this.$t('ads.修改成功'));
              this.open = false;
              this.getList();
            });
          } else {
            addAds(this.form).then(response => {
              this.$modal.msgSuccess(this.$t('ads.新增成功'));
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm(this.$t('ads.是否确认删除数据项')).then(function() {
        return delAds(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess(this.$t('ads.删除成功'));
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('system/ads/export', {
        ...this.queryParams
      }, `ads_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
